diff --git a/src/main/java/net/minecraft/client/render/MapItemRenderer.java b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
index 383e6fe05..1f14956ad 100644
--- a/src/main/java/net/minecraft/client/render/MapItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
@@ -4,7 +4,6 @@ import java.awt.image.BufferedImage;
 import java.util.Iterator;
 
 import net.minecraft.client.render.texture.BufferedTexture;
-import net.minecraft.core.util.helper.MathHelper;
 
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -25,12 +24,12 @@ public class MapItemRenderer
     public static final int IMAGE_HEIGHT = 128;
     public static final int IMAGE_AREA = 128 * 128;
 
-    public MapItemRenderer(FontRenderer fontrenderer, GameSettings gamesettings, RenderEngine renderengine)
+    public MapItemRenderer(Font font, GameSettings gamesettings, TextureManager textureManager)
     {
         mapImageData = new int[IMAGE_AREA];
         gameSettings = gamesettings;
-        fontRenderer = fontrenderer;
-        mapTexture = renderengine.loadBufferedTexture(new BufferedImage(128, 128, 2));
+        this.font = font;
+        mapTexture = textureManager.loadBufferedTexture(new BufferedImage(128, 128, 2));
         for(int i = 0; i < IMAGE_AREA; i++)
         {
             mapImageData[i] = 0;
@@ -39,11 +38,11 @@ public class MapItemRenderer
     }
 
 
-    public void renderMap(RenderEngine renderengine, ItemMapSavedData mapdata, float brightness)
+    public void renderMap(TextureManager textureManager, ItemMapSavedData data, float brightness)
     {
         for(int i = 0; i < IMAGE_AREA; i++)
         {
-            int colorIndex = mapdata.colors[i];
+            int colorIndex = data.colors[i];
             //value is divided by 4 to get the map colour id
             if(colorIndex >> 2 == 0)
             {
@@ -75,7 +74,7 @@ public class MapItemRenderer
         }
 
 
-        renderengine.updateTextureData(mapImageData, 128, 128, mapTexture.id());
+        textureManager.updateTextureData(mapImageData, 128, 128, mapTexture.id());
         int j = 0;
         int k = 0;
         Tessellator tessellator = Tessellator.instance;
@@ -92,9 +91,9 @@ public class MapItemRenderer
         tessellator.draw();
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glDisable(GL11.GL_BLEND);
-        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
+        textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
 
-        for(Iterator<MapWaypoint> iterator = mapdata.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix())
+        for(Iterator<MapWaypoint> iterator = data.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix())
         {
             MapWaypoint mapWaypoint = iterator.next();
             GL11.glPushMatrix();
@@ -115,8 +114,8 @@ public class MapItemRenderer
             tessellator.draw();
         }
         //renders map icons
-        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
-        for(Iterator<ItemMapSavedData.MapDecoration> iterator = mapdata.decorations.iterator(); iterator.hasNext(); GL11.glPopMatrix())
+        textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
+        for(Iterator<ItemMapSavedData.MapDecoration> iterator = data.decorations.iterator(); iterator.hasNext(); GL11.glPopMatrix())
         {
             ItemMapSavedData.MapDecoration mapcoord = iterator.next();
             GL11.glPushMatrix();
@@ -142,9 +141,9 @@ public class MapItemRenderer
         }
         GL11.glPushMatrix();
 
-        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/flagicon.png"));
+        textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/flagicon.png"));
         // begin drawing flag colors
-        for(Iterator<MapWaypoint> iterator = mapdata.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix()) {
+        for(Iterator<MapWaypoint> iterator = data.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix()) {
             MapWaypoint mapWaypoint = iterator.next();
             GL11.glPushMatrix();
             for (int y = 0; y < 3; y++) {
@@ -185,5 +184,5 @@ public class MapItemRenderer
     private final int[] mapImageData;
     private final BufferedTexture mapTexture;
     private final GameSettings gameSettings;
-    private FontRenderer fontRenderer;
+    private Font font;
 }
diff --git a/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index 6b545d69b..9450e1ac9 100644
--- a/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -5,6 +5,7 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.HashSet;
 import java.util.Set;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import org.lwjgl.opengl.ARBFramebufferObject;
 import org.lwjgl.opengl.ContextCapabilities;
@@ -12,10 +13,11 @@ import org.lwjgl.opengl.GLContext;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.shader.Shaders;
+import org.slf4j.Logger;
 
 public class OpenGLHelper {
-	
-	private static Set<String> errors = new HashSet<>();
+	private static final Logger LOGGER = LogUtils.getLogger();
+	private static final Set<String> errors = new HashSet<>();
 	
 	public static boolean enableOcclusionCheck = false;
 	public static boolean enableSphericalFog = false;
@@ -23,15 +25,15 @@ public class OpenGLHelper {
 	public static boolean gl31 = false;
 	
     public static void testCapabilities(Minecraft minecraft) {
-        System.out.println(glGetString(GL_VERSION));
-        System.out.println(glGetString(GL_VENDOR));
-        System.out.println(glGetString(GL_RENDERER));
+        LOGGER.info(glGetString(GL_VERSION));
+        LOGGER.info(glGetString(GL_VENDOR));
+        LOGGER.info(glGetString(GL_RENDERER));
         
         ContextCapabilities capabilities = GLContext.getCapabilities();
 
-        System.out.println("GL_ARB_framebuffer_object: " + capabilities.GL_ARB_framebuffer_object);
-        System.out.println("GL_ARB_occlusion_query: " + capabilities.GL_ARB_occlusion_query);
-        System.out.println("GL_NV_fog_distance: " + capabilities.GL_NV_fog_distance);
+        LOGGER.info("GL_ARB_framebuffer_object: {}", capabilities.GL_ARB_framebuffer_object);
+        LOGGER.info("GL_ARB_occlusion_query: {}", capabilities.GL_ARB_occlusion_query);
+        LOGGER.info("GL_NV_fog_distance: {}", capabilities.GL_NV_fog_distance);
         
         enableOcclusionCheck = capabilities.GL_ARB_occlusion_query;
         enableSphericalFog = capabilities.GL_NV_fog_distance;
@@ -40,13 +42,13 @@ public class OpenGLHelper {
         
 		if(minecraft.gameSettings.disableShaders.value) {
 			Shaders.enableShaders = false;
-			System.out.println("Shaders disabled in options file!");
+			LOGGER.info("Shaders disabled in options file!");
 			return;
 		}
 		
 		Shaders.enableShaders = capabilities.GL_ARB_framebuffer_object && capabilities.OpenGL20;
-		
-		System.out.println("Enable Shaders: " + Shaders.enableShaders);
+
+        LOGGER.info("Enable Shaders: {}", Shaders.enableShaders);
     }
 	
 	public static void checkError(String info) {
@@ -61,8 +63,8 @@ public class OpenGLHelper {
 			if(!errors.contains(info)) {
 				errors.add(info);
 				String error = errorCode + " (" + getErrorDescription(errorCode) + "): " + info;
-	            System.out.println("########## GL ERROR ##########");
-				System.out.println("OpenGL Error "+error);
+	            LOGGER.error("########## GL ERROR ##########");
+                LOGGER.error("OpenGL Error {}", error);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/client/render/ParticleEngine.java b/src/main/java/net/minecraft/client/render/ParticleEngine.java
new file mode 100644
index 000000000..94ddc68ca
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -0,0 +1,210 @@
+package net.minecraft.client.render;
+
+import java.util.*;
+
+import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.entity.particle.TerrainParticle;
+import net.minecraft.client.entity.particle.Particle;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import org.lwjgl.opengl.GL11;
+
+/**
+ * Handles rendering and ticking of client-side particles.
+ */
+public final class ParticleEngine {
+    public static final int MISC_TEXTURE = 0;
+    public static final int TERRAIN_TEXTURE = 1;
+    public static final int ITEM_TEXTURE = 2;
+    public static final int ENTITY_PARTICLE_TEXTURE = 3;
+    public static final int TEXTURE_COUNT = 4;
+
+    private World world;
+    private final List<Particle>[] particles;
+    private final Random rand;
+
+    public ParticleEngine(World world) {
+        particles = new ArrayList[TEXTURE_COUNT];
+        rand = new Random();
+        if (world != null) {
+            this.world = world;
+        }
+        for (int i = 0; i < particles.length; i++) {
+            particles[i] = new ArrayList<>();
+        }
+    }
+
+    /**
+     * Adds a new particle to the engine.
+     * @param p The particle to add.
+     */
+    public void add(Particle p) {
+        int t = p.getParticleTexture();
+        if (particles[t].size() >= 4000) {
+            particles[t].remove(0);
+        }
+        particles[t].add(p);
+    }
+
+    /**
+     * Ticks all the particles in the engine.
+     */
+    public void tick() {
+        for (int tt = 0; tt < particles.length; tt++) {
+            for (int i = 0; i < particles[tt].size(); i++) {
+                Particle p = particles[tt].get(i);
+                p.tick();
+                if (p.removed) {
+                    particles[tt].remove(i--);
+                }
+            }
+        }
+    }
+
+    /**
+     * Renders all the particles in the engine.
+     * @param camera The camera relative to whose perspective the particles should be drawn.
+     * @param partialTick The time since the last tick.
+     */
+    public void renderParticles(ICamera camera, float partialTick) {
+        double yRot = camera.getYRot(partialTick);
+        double xRot = camera.getXRot(partialTick);
+        float xa = MathHelper.cos((float) (yRot * Math.PI) / 180F);
+        float za = MathHelper.sin((float) (yRot * Math.PI) / 180F);
+        float xa2 = -za * MathHelper.sin((float) ((xRot * Math.PI) / 180F));
+        float za2 = xa * MathHelper.sin((float) ((xRot * Math.PI) / 180F));
+        float ya = MathHelper.cos((float) ((xRot * Math.PI) / 180F));
+        double xOff = camera.getX(partialTick);
+        double yOff = camera.getY(partialTick);
+        double zOff = camera.getZ(partialTick);
+
+        for (int tt = 0; tt < 3; tt++) {
+            if (particles[tt].isEmpty()) {
+                continue;
+            }
+            int texture = 0;
+            if (tt == MISC_TEXTURE) {
+                texture = TextureRegistry.particleAtlas.id();
+            }
+            if (tt == TERRAIN_TEXTURE) {
+                texture = TextureRegistry.blockAtlas.id();
+            }
+            if (tt == ITEM_TEXTURE) {
+                texture = TextureRegistry.itemAtlas.id();
+            }
+            GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture);
+            Tessellator tessellator = Tessellator.instance;
+            tessellator.startDrawingQuads();
+            for (int i = 0; i < particles[tt].size(); i++) {
+                Particle p = particles[tt].get(i);
+                p.render(tessellator, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
+            }
+
+            tessellator.draw();
+        }
+    }
+
+    /**
+     * Renders all the particles in the engine whose texture type is ENTITY_PARTICLE_TEXTURE.
+     * These particles are drawn using OpenGL normal-based lighting, unlike the other particles,
+     * as they are full 3D rather than billboarded sprites.
+     * @param camera The camera relative to whose perspective the particles should be drawn.
+     * @param partialTick The time since the last tick.
+     */
+    public void renderLitParticles(ICamera camera, float partialTick) {
+        int tt = ENTITY_PARTICLE_TEXTURE;
+        if (particles[tt].isEmpty()) {
+            return;
+        }
+        double xOff = camera.getX(partialTick);
+        double yOff = camera.getY(partialTick);
+        double zOff = camera.getZ(partialTick);
+        Tessellator tessellator = Tessellator.instance;
+        for (int i = 0; i < particles[tt].size(); i++) {
+            Particle p = particles[tt].get(i);
+            p.render(tessellator, partialTick, xOff, yOff, zOff, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F);
+        }
+
+    }
+
+    /**
+     * Sets the world used to contain any managed particles.
+     * @param world The world to use.
+     */
+    public void setWorld(World world) {
+        this.world = world;
+        for (int i = 0; i < TEXTURE_COUNT; i++) {
+            particles[i].clear();
+        }
+    }
+
+    /**
+     * Produces a burst of terrain particles at the location a block is destroyed.
+     * @param x The X coordinate of the destroyed block.
+     * @param y The Y coordinate of the destroyed block.
+     * @param z The Z coordinate of the destroyed block.
+     * @param id The ID of the destroyed block.
+     * @param data The metadata value of the destroyed block.
+     */
+    public void destroy(int x, int y, int z, int id, int data) {
+        Block block = Block.blocksList[id];
+        if (block == null) return;
+        int amount = 4;
+        if (block == Blocks.FIRE) {
+            return;
+        }
+        for (int xx = 0; xx < amount; xx++) {
+            for (int yy = 0; yy < amount; yy++) {
+                for (int zz = 0; zz < amount; zz++) {
+                    double xp = x + (xx + 0.5D) / amount;
+                    double yp = y + (yy + 0.5D) / amount;
+                    double zp = z + (zz + 0.5D) / amount;
+                    Side side = Side.getSideById(rand.nextInt(6));
+                    add((new TerrainParticle(world, xp, yp, zp, xp - x - 0.5D, yp - y - 0.5D, zp - z - 0.5D, block, side, data)).init(x, y, z));
+                }
+            }
+        }
+    }
+
+    /**
+     * Produces falling terrain particles along the side of a block.
+     * @param x The X coordinate of the block.
+     * @param y The Y coordinate of the block.
+     * @param z The Z coordinate of the block.
+     * @param side The side along which to produce particles.
+     */
+    public void crack(int x, int y, int z, Side side) {
+        int id = world.getBlockId(x, y, z);
+        if (id == 0) {
+            return;
+        }
+        Block block = Block.blocksList[id];
+        float r = 0.1F;
+        double xp = x + rand.nextDouble() * (block.maxX - block.minX - (r * 2.0F)) + r + block.minX;
+        double yp = y + rand.nextDouble() * (block.maxY - block.minY - (r * 2.0F)) + r + block.minY;
+        double zp = z + rand.nextDouble() * (block.maxZ - block.minZ - (r * 2.0F)) + r + block.minZ;
+        if (side == Side.BOTTOM) {
+            yp = (y + block.minY) - r;
+        } else if (side == Side.TOP) {
+            yp = (y + block.maxY) + r;
+        } else if (side == Side.NORTH) {
+            zp = (z + block.minZ) - r;
+        } else if (side == Side.SOUTH) {
+            zp = (z + block.maxZ) + r;
+        } else if (side == Side.WEST) {
+            xp = (x + block.minX) - r;
+        } else if (side == Side.EAST) {
+            xp = x + block.maxX + r;
+        }
+        add((new TerrainParticle(world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, world.getBlockMetadata(x, y, z))).init(x, y, z).setPower(0.2F).setScale(0.6F));
+    }
+
+    public int countParticles() {
+        return particles[MISC_TEXTURE].size() + particles[TERRAIN_TEXTURE].size() + particles[ITEM_TEXTURE].size();
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 7423d47e6..859cd1d46 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -983,7 +983,7 @@ public class RenderBlocks
         }
     }
 
-    public void renderBlockAsItem(Tessellator tessellator, BlockModel<Block> blockModel, Block block, float var2)
+    public void renderBlockAsItem(Tessellator tessellator, BlockModel<?> blockModel, Block block, float var2)
     {
         blockModel.setBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
